//###################################################################################
// File: dosmkdir2.c
//
// Crashtest: 200 Verzeichnisse und 200 Dateien anlegen
//
//#########################################################################
// Last change: 06.12.2007
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 4.1.1
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../lcd.h"
#include "../dos.h"
#include "../printf.h"
#include "../serial.h"

//"volatile" fr alle Variablen die in Interrupt's gendert werden
unsigned int volatile countclock;

//###################################################################################
// timeout not used !
// interrupt every 47.4ms  @ 11.0592MHz
// interrupt every 32.77ms @ 16.0000MHz
SIGNAL(SIG_OVERFLOW1)        // signal handler for timer1 overflow interrupt
//###################################################################################
{
 countclock++;
}

//###################################################################################
unsigned char WriteTestFile(char *name)
//###################################################################################
{
 unsigned char result;
 unsigned long bytecount;

 bytecount=0;
 result=Fopen(name,F_WRITE);
 if(result==F_OK)
  {
   do
    {
     if(Fwrite("Hello World. Hello World. Hello World. Hello World.\n",52)!=52) result=F_ERROR;
     if(result!=F_ERROR) bytecount+=(unsigned long)52;

    }while(bytecount < (unsigned long)64000 && result==F_OK );

   Fclose();
  }

 return result;
}

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 char filename[13],buf[8];
 int i;
 
 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

// SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

#ifdef MMC_CARD_SPI //SD_CARD_SPI too !
 MMC_IO_Init();
#endif

 ser_init();

//Timer1
 TCCR1A=0; 
 TCCR1B=0x02;        //Timer1 Start Takt = F/8 => 47.4ms at 11.059MHz
#if defined (__AVR_ATmega644__)
  TIMSK1=(1<<TOIE1);   // enable timer1 int
#else
  TIMSK=(1<<TOIE1);   // enable timer1 int
#endif

 sei();              //enable interrupts

 printf("FAT Crash-Test\n");

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   printf("No Flash !\n");
   while(1);
  }
  
 RED_ON();
 GREEN_OFF();

 Mkdir("test1"); // Do it in a subdirectory !
 Chdir("test1");

 for(i=1; i<=200; i++)
  {
   strcpy(filename,"DIR");
   itoa(i,buf,10);
   strcat(filename,buf);
   Mkdir(filename);
   printf("DIR%d\n",i);
  }

 for(i=1; i<=200; i++)
  {
   strcpy(filename,"FILE");
   itoa(i,buf,10);
   strcat(filename,buf);
   WriteTestFile(filename);
   printf("FILE%d\n",i);
  }


 GREEN_ON();
 RED_OFF();
 printf("Test done\n");

 cli(); // Disable interrupts
 
 for(;;) // loop forever
  {
  }
}

