//#########################################################################
// File: MYDEFS.H
//
//
//#########################################################################
// Last change: 09.08.2007
//#########################################################################
// Compiler: AVR-GCC 4.1.1
//#########################################################################


#ifndef __MYDEFS_H
#define __MYDEFS_H

#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))

#if defined (__AVR_ATmega32__) || defined (__AVR_ATmega323__) || defined (__AVR_ATmega644__)
 #define RED_BIT	7	//Pin number for red LED
 #define RED_PORT 	PORTD   //Port where red LED is located
 #define RED_DDR 	DDRD    //Port direction register where red LED is located
 #define GREEN_BIT	6	//Pin number for green LED
 #define GREEN_PORT 	PORTD   //Port where green LED is located
 #define GREEN_DDR 	DDRD    //Port direction register where green LED is located
#elif defined (__AVR_ATmega128__) || defined (__AVR_ATmega64__)
 #define RED_BIT	7	//Pin number for red LED
 #define RED_PORT 	PORTE   //Port where red LED is located
 #define RED_DDR 	DDRE    //Port direction register where red LED is located
 #define GREEN_BIT	6	//Pin number for green LED
 #define GREEN_PORT 	PORTE   //Port where green LED is located
 #define GREEN_DDR 	DDRE    //Port direction register where green LED is located
#elif defined (__AVR_ATmega168__) || defined (__AVR_ATmega8__) || defined (__AVR_ATmega88__)
 #define RED_BIT	5	//Pin number for red LED
 #define RED_PORT 	PORTD   //Port where red LED is located
 #define RED_DDR 	DDRD    //Port direction register where red LED is located
 #define GREEN_BIT	4	//Pin number for green LED
 #define GREEN_PORT 	PORTD   //Port where green LED is located
 #define GREEN_DDR 	DDRD    //Port direction register where green LED is located

#else
#  error "processor type not defined in mydefs.h"
#endif

//Die beiden LED's
#define RED_ON() { sbi(RED_DDR,RED_BIT); cbi(RED_PORT,RED_BIT); } //LOW activ
#define RED_OFF() { sbi(RED_DDR,RED_BIT); sbi(RED_PORT,RED_BIT); } //LOW activ

#define GREEN_ON() { sbi(GREEN_DDR,GREEN_BIT); cbi(GREEN_PORT,GREEN_BIT); }  //LOW activ
#define GREEN_OFF() { sbi(GREEN_DDR,GREEN_BIT); sbi(GREEN_PORT,GREEN_BIT); } //LOW activ


//#define MODE	bit_is_set(PINA,PA0)

#endif //__MYDEFS_H
